
// Returns number of 1s in value
int countOnes(unsigned int value) {
	// Get number of bits in unsigned int
	// shift left 3 times is equivalent to multiplying by 8
	int n = (sizeof(value) << 3);

	int i;
	int numOnes = 0;
	for (i=0; i < n; i++) {
		// Check bit at ith position
		unsigned int mask = (1 <<i);
		if ((value & mask) != 0) {
			numOnes++;
		}
	}

	return numOnes;
}

int main()
{
	printf("countOnes(0x30303)=%d\n",
	       countOnes(0x30303));
}
