
#include <stdlib.h>

int strlen(char * str) {

	int i = 0;

	while (*str) {
		str++;
		i++;
	}

	return i;
}

char * strcpy(char * dest, char * src) {

	char * p = src;
	char * q = dest;
	while (*p) {
		*q = *p;
		p++;
		q++;
	}
	*q = '\0';
	return dest;
}

char * strcat(char * dest, char * src) {
	// Find end of dest
	char * q = dest;
	while (*q) {
		q++;
	}

	// Now copy src at the end of dest
	char * p = src;
	while (*p) {
		*q = *p;
		p++;
		q++;
	}
	*q = '\0';
	return dest;
}

char * strstr(char * hay, char * needle) {
	// Compare until the end of hay
	while (*hay) {
		char * p = hay;
		char * q = needle;
		// Compare character by character until end of needle or hay
		while (*p && *q && *p == *q) {
			p++;
			q++;
		}
		if (*q=='\0') {
			// If we reached the end of needle then needle is
			// contained by hay
			return hay;
		}
		// Needle not contained in hay at that position. Increase hay
		hay++;
	}

	// Needle not found in hay
	return NULL;
}

